=== debian/changelog ===
synergy (1.14.1.32+dfsg-1~mx21+1) mx; urgency=medium

  * Initial build from upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Thu, 11 Nov 2021 14:34:39 -0500

synergy (1.14.1.32+dfsg-1~xtradeb1) focal; urgency=medium

  * New upstream release.
   - Bug fixes:
    - #7016 Fix script that generates version number
    - #7006 Resolve code scanning issues
    - #7012 Fix natural horizontal scrolling on Mac client
    - #6997 Allow Windows to go to sleep depending on system preferences
    - #7001 Add option to prevent computer from going to sleep
    - #7029 | #7033 Wrong encoding for text copied between linux and windows
    - #7015 Fix Windows service not starting up after sleep
    - #7036 Fix tray icon not changing theme on Big Sur
    - #7046 Fix MacOS 10.13 build
    - #7049 Scroll doesn't work in case of macOS is server
    - #7057 | #7058 Fix copy paste logic, when OS reported about clipboard
      update too late
    - #7055 | #7066 Add secure input notification on Linux
    - #7052 Add secure input notification on Windows
    - #7047 | #7060 Fix prevent sleep option on Mac and Windows
    - #7064 There is no secure input notification if user moves pointer between
      clients
   - Enhancements:
    - #6998 Remove functionality related to the screen saver synchronisation
    - #7026 Update the way we package OpenSSL for Windows build
    - #7035 Add Fedora 34 build
    - #7037 Add Ubuntu 21.04 build
    - #7030 | #7041 | #7043 Add user notification for secure input on Mac
    - #7044 Apply natural scroll setting independently on each client
    - #7040 Support "Kana" and "Eisu" keys on Japanese Apple Pro Keyboard (JIS)
    - #7047 Add prevent sleep option support to Linux

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Thu, 16 Sep 2021 11:24:42 +0000

synergy (1.14.0.4+dfsg-1~xtradeb1) focal; urgency=medium

  * New upstream release.
   - Bug fixes:
    - #6953 | #6961 The system does not update server name in Server
      configuration
    - #6966 macOS 10.13 missing build number
    - #6968 System loses synchronisation between settings and configuration
    - #6972 Fix SonarCloud security hotspots
    - #6971 Fix vulnerabilities from SonarCloud
    - #6974 Fix macOS 10.13 application files
    - #6975 Fix server stop working
    - #6976 Fix windows builds
    - #6979 Manual config error in client mode
    - #6983 Fix that mac client listens on ipv4 only
    - #6989 Fix client tray language switcher reverts to EN
    - #6993 Fix issues with prefences UI
    - #6992 UI issues and use cases
    - #7000 Additional UI tweaks
    - #7005 Fix User is not able to connect to server using ipv6 without
      wrapping IP in square quotes
    - #7009 Clipboard sharing doesn't work on Linux system
    - #7010 Fix Ubuntu 16.04 pipeline in Azure
    - #7011 Fix language synchronisation checkbox spelling
    - #7013 Wrong connection pop up appears if the user connects using a domain
      name which is assigned to list of IP's
    - #7014 Temporary disable language sync logic
    - #7020 Remove cmake option for autoconfig
   - Enhancements:
    - #6954 Move language selection to advanced section
    - #6959 Update synergy UI. Setup wizard
    - #6969 Update synergy UI. Validation for aliases.
    - #6973 Update synergy UI. Main window
    - #6977 Update synergy UI. Configure server
    - #6978 Update synergy UI. Settings window
    - #6981 | #6987 | #6988 | #6996 Update synergy UI. Setup client
      configuration
    - #6984 Update synergy UI. Client error messages
    - #6962 | #6965 Add macOS 10.13 builder
    - #6990 Change VersionChecker URL and include system language in the header
    - #6999 Detect if Linux is running with Wayland, and display a warning
      message
    - #7003 | #7024 Prioritization rules server config
    - #7004 Add openssl dependency for rpm
    - #7008 Add logging when hostname have several IP
    - #7022 Add Fedora 33 to build and release pipeline
    - #7031 New china licenses

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sat, 12 Jun 2021 09:12:45 +0000

synergy (1.13.1.41-1~xtradeb1) focal; urgency=medium

  * New upstream release.
   - Bug fixes:
    - #6900 Remaining SonarCloud reported bug items
    - #6903 Save global settings
    - #6889 Systray Icon on Ubuntu Auto Start (take 2)
    - #6907 Saving configuration on apply
    - #6934 Text on welcome screen on macOS is shown without spaces
    - #6920 Windows Installer checksums
    - #6921 Handling pre-main window creation status notifications
    - #6922 macOS CI build
    - #6927 Text copied and pasted between Windows and Mac OS converts to
      Japanese
    - #6936 Application loses settings
    - #6939 Update pipelines to use correct credentials
    - #6942 All the text in all the windows should have the same font and size
    - #6944 Systray icon is incorrect for macOS Big Sur
    - #6941 The application doesn't recognize old settings
    - #6945 Fix build for Raspberry Pi
    - #6946 Add build stage to filename
    - #6950 Synergy client doesn't save the server address when rebooted
    - #6951 Fix issue creating standard version for Raspberry Pi
   - Enhancements:
    - #6912 Removes UI for Screen Saver Sync and Files Drag and Drop
    - #6909 Document CLI Arguments
    - #6916 Main Window receives screen name change
    - #6910 Don't use the word “Version” for release names because it can lead
      to errors during update checking.
    - #6918 Removing positional union initialisation
    - #6931 Update build pipeline to support macOS 10.13
    - #6937 Modern C++ compiler for centOS7
    - #6938 Remove auto config message from the main window
    - #6941 Add Raspberry Pi Builds
    - #6949 Add a new option SYNERGY_AUTOCONFIG to exclude autoconfig from the
      standard version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sun, 14 Mar 2021 13:24:22 +0000

synergy (1.13.0-1~xtradeb2) focal; urgency=medium

  * Include watch file


