=== debian/control ===
Source: synergy
Section: utils
Priority: optional
Standards-Version: 4.5.0
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Symless <engineering@symless.com>, Jhonny Oliveira <jhonny.oliveira@gmail.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libavahi-compat-libdnssd-dev,
               libssl-dev,
               libxt-dev,
               libxtst-dev,
               libx11-dev,
               libxi-dev,
               libxrandr-dev,
               libxinerama-dev,
               qtbase5-dev,
               qttools5-dev,
               googletest,
               libglib2.0-dev,
               libgdk-pixbuf2.0-dev,
               libnotify-dev
Homepage: https://symless.com/synergy

Package: synergy
Architecture: any
Section: utils
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Keyboard and mouse sharing solution
 Synergy allows you to share one mouse and keyboard between multiple computers.
 Work seamlessly across Windows, macOS and Linux.
