=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export BUILDDIR=.build

%:
	dh $@ --builddir=$(BUILDDIR)

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_clean:
	rm -Rf ext/googletest/*
	dh_auto_clean

override_dh_auto_configure:
	cp -r /usr/src/googletest/* ext/googletest/
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:
	$(BUILDDIR)/bin/unittests
	$(BUILDDIR)/bin/integtests
