=== debian/watch ===
version=4
opts="dversionmangle=s!\+dfsg!!, \
      oversionmangle=s!(.+)!$1+dfsg!" \
 https://github.com/symless/synergy-core/releases/latest \
    (?:.*/)?v?([\d\.]+)(?:-stable)?\.tar\.gz
